
#include "../config.h"

#include <gtk/gtk.h>
#include <orbit/orbit.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "gtk2sample.h"

static void incr_counter(Counter counter, const char* entry_name)
{
    Counter_incr(counter, &ev);
    int r = Counter__get_value(counter, &ev);

    char buf[100];
    sprintf(buf, "%d", r);
    GtkWidget* entry = lookup_widget(button, entry_name);
    gtk_entry_set_text(GTK_ENTRY(entry), buf);
}

static void decr_counter(Counter counter, const char* entry_name)
{
    Counter_decr(counter, &ev);
    int r = Counter__get_value(counter, &ev);

    char buf[100];
    sprintf(buf, "%d", r);
    GtkWidget* entry = lookup_widget(button, entry_name);
    gtk_entry_set_text(GTK_ENTRY(entry), buf);
}

void
on_norm_incr_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
    incr_counter(csets[0].counter, "norm_entry");
}


void
on_norm_decr_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
    decr_counter(csets[0].counter, "norm_entry");
}


void
on_rev_incr_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
    incr_counter(csets[1].counter, "rev_entry");

}


void
on_rev_decr_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
    decr_counter(csets[1].counter, "rev_entry");
}


