/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#include "../config.h"

#include <gtk/gtk.h>
#include <orbit/orbit.h>
#ifdef USE_NAME_SERVICE
  #include <ORBitservices/CosNaming.h>
#endif

#include "interface.h"
#include "support.h"
#include "gtk2sample.h"
#include "../misc.h"

CORBA_Environment ev;
CounterSet csets[2];

#ifndef USE_NAME_SERVICE
const char* ior_file = "../counter.ior";
#endif

int
main (int argc, char *argv[])
{
  GtkWidget *window1;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

    CORBA_exception_init(&ev);
    CORBA_ORB orb = CORBA_ORB_init(&argc, argv, "orbit-local-orb", &ev);
    
#ifdef USE_NAME_SERVICE
    CosNaming_NamingContext naming
        = CORBA_ORB_resolve_initial_references(orb, "NameService", &ev);
    if (!naming) {
        printf("resolve NameService failed.\n");
        return 1;
    }

    CosNaming_Name* name = CosNaming_Name__alloc();
    name->_length = 1;
    name->_buffer = CORBA_sequence_CosNaming_NameComponent_allocbuf(1);
    name->_buffer->id = CORBA_string_dup("Counter");
    name->_buffer->kind = CORBA_string_dup("");
    csets[0].counter = CosNaming_NamingContext_resolve(naming, name, &ev);

    name = CosNaming_Name__alloc();
    name->_length = 1;
    name->_buffer = CORBA_sequence_CosNaming_NameComponent_allocbuf(1);
    name->_buffer->id = CORBA_string_dup("ReverseCounter");
    name->_buffer->kind = CORBA_string_dup("");
    csets[1].counter = CosNaming_NamingContext_resolve(naming, name, &ev);
#else
    FILE* fp = fopen(ior_file, "r");
    if (!fp) {
        perror("file open");
        return 1;
    }
    csets[0].counter = CORBA_ORB_string_to_object(
                                  orb, read_line(fp), &ev);
    csets[1].counter = CORBA_ORB_string_to_object(
                                  orb, read_line(fp), &ev);
    fclose(fp);
#endif // USE_NAME_SERVICE

    if (!csets[0].counter || !csets[1].counter) {
        printf("ior error.\n");
        return 1;
    }

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = create_window1 ();
  gtk_widget_show (window1);

  gtk_main ();

    CORBA_Object_release(csets[0].counter, &ev);
    CORBA_Object_release(csets[1].counter, &ev);

  return 0;
}

