// server for JDK 1.2

import org.omg.CORBA.ORB;
import java.io.File;
import java.io.FileWriter;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContext;
import org.omg.CosNaming.NamingContextHelper;

class CounterImpl implements CounterOperations
{
    protected short count_;

    public CounterImpl() { super(); count_ = 0; }
    public short value() { return count_; }
    public void incr() { count_++; }
    public void decr() { count_--; }
    public String name() { return "Counter"; }
};

class ReverseCounterImpl extends CounterImpl implements ReverseCounterOperations
{
    public ReverseCounterImpl() { super(); count_ = 1000; }
    public void incr() { count_--; }
    public void decr() { count_++; }
    public String name() { return "ReverseCounter"; }
};

class Server
{
    public static void main(String[] args) {
        try {
            ORB orb = ORB.init(args, null);
            Counter_Tie ncRef
                    = new Counter_Tie(new CounterImpl());
            ReverseCounter_Tie rcRef
                    = new ReverseCounter_Tie(new ReverseCounterImpl());
            orb.connect(ncRef);
            orb.connect(rcRef);

            // IORt@Cɏo
            FileWriter out = new FileWriter("../counter.ior");
            String ncIOR = orb.object_to_string(ncRef);
            String rcIOR = orb.object_to_string(rcRef);
            out.write(ncIOR + "\n");
            out.write(rcIOR + "\n");
            out.close();
/*
            org.omg.CORBA.Object nameRef
                = orb.resolve_initial_references("NameService");
            NamingContext naming = NamingContextHelper.narrow(nameRef);

            NameComponent nc = new NameComponent("q.Counter", "");
            NameComponent[] pathNC = { nc };
            naming.rebind(pathNC, ncRef);

            NameComponent rc = new NameComponent("q.ReverseCounter", "");
            NameComponent[] pathRC = { rc };
            naming.rebind(pathRC, rcRef);
*/
            // C[v
            System.out.println("ready.");
            java.lang.Object sync = new java.lang.Object();
            synchronized(sync) {
                sync.wait();
            }
        }
        catch (Exception e) {
            e.printStackTrace(System.err);
        }
    }
};
