
# include "../config.h"

#include <stdio.h>
#include <stdlib.h>
#include <orbit/orbit.h>

#ifdef USE_NAME_SERVICE
  #include <ORBitservices/CosNaming.h>
#elif defined(USE_OAF)
  #include <liboaf/liboaf.h>
#endif

#include "counter.h"
#include "impl_counter.h"

////////////////////////////////////////////////////////////////////////
// ReverseCounterImpl

static void RCImpl_incr(PortableServer_Servant servant, CORBA_Environment* ev) {
    Counter_DATA(servant)->value--;
}

static void RCImpl_decr(PortableServer_Servant servant, CORBA_Environment* ev) {
    Counter_DATA(servant)->value++;
}

static CORBA_char* RCImpl_name(PortableServer_Servant servant,
                                    CORBA_Environment* ev) {
    return CORBA_string_dup("ReverseCounter");
}

// vtable
void RCImpl_epv_init(POA_ReverseCounter__vepv* vepv) {
    CounterImpl_epv_init((POA_Counter__vepv*) vepv);
    vepv->Counter_epv->incr = RCImpl_incr;  // С饤ɤ
    vepv->Counter_epv->decr = RCImpl_decr;
    vepv->Counter_epv->name = RCImpl_name;
    vepv->ReverseCounter_epv = (POA_ReverseCounter__epv*)
                                      malloc(sizeof(POA_ReverseCounter__epv));
    vepv->ReverseCounter_epv->_private = NULL;
}

POA_ReverseCounter* RCImpl_new(CORBA_Environment* ev)
{
    POA_ReverseCounter* servant = (POA_ReverseCounter*) malloc(sizeof(POA_ReverseCounter));
    servant->_private = NULL; // ORBit
    servant->vepv = (POA_ReverseCounter__vepv*) malloc(sizeof(POA_ReverseCounter__vepv));
    RCImpl_epv_init(servant->vepv);

    servant->vepv->Counter_epv->_private = new CounterData(1000);
    POA_ReverseCounter__init(servant, ev);
          // 
          //    PortableServer_ServantBase__init() 
          //    POA_Counter__init() ƤӽФƤ
    return servant;
}

void RCImpl_finalize(POA_ReverseCounter__vepv* vepv)
{
    free(vepv->ReverseCounter_epv);
    CounterImpl_finalize((POA_Counter__vepv*) vepv);
}

void RCImpl_delete(POA_ReverseCounter* servant, CORBA_Environment* ev)
{
    POA_ReverseCounter__fini(servant, ev); // POA_Counter__fini()ƤӽФƤ
    delete (CounterData*) servant->vepv->Counter_epv->_private;
    RCImpl_finalize(servant->vepv);
    free(servant->vepv);
    free(servant);
}
